"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = beforeAction;
exports.VUE_LIKE_METHODS = void 0;

require("core-js/modules/web.dom.iterable");

var _mobx = require("./mobx");

var _utils = require("./utils");

var _component = _interopRequireDefault(require("./component"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const RESERVED_METHODS = ['constructor', 'data', 'provide', 'shouldComponentUpdate', 'render', 'renderError'];
const VUE_LIKE_METHODS = Object.getOwnPropertyNames(_component.default.prototype).filter(function (key) {
  return !_utils.ClassPropertyNames.includes(key);
});
exports.VUE_LIKE_METHODS = VUE_LIKE_METHODS;

function _handleAction(target, key, flows) {
  let v = target[key];
  if (!(0, _utils.isFunction)(v)) return;
  let isFlow = flows.includes(key);
  let n = isFlow ? (0, _mobx.flow)(v) : (0, _mobx.action)(key, v);
  if (v !== n) target[key] = n;
}

function beforeAction(target) {
  if (!target) return;
  let flows = target.__flows || [];

  if (target.methods) {
    Object.keys(target.methods).forEach(function (key) {
      return _handleAction(target.methods, key, flows);
    });
  }

  let reserved = RESERVED_METHODS;
  if (target.__vuelikeWrapper) reserved = reserved.concat(VUE_LIKE_METHODS);
  target.prototype && Object.getOwnPropertyNames(target.prototype).forEach(function (key) {
    return !reserved.includes(key) && _handleAction(target.prototype, key, flows);
  }); // Object.getOwnPropertyNames(target)
  //   .forEach(key => !reserved.includes(key) && _handleAction(target.prototype, key, flows));
}