"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

var _react = _interopRequireDefault(require("react"));

var _config = _interopRequireDefault(require("./config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

const hasSymbol = typeof Symbol === 'function' && Symbol.for;
const REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;

class Collect {
  get isRendering() {
    return Boolean(this.elements);
  }

  start() {
    this.elements = [];
  }

  end(root) {
    let elements = this.elements || [];
    this.elements = null;

    const getRoot = function (root) {
      if (!root) return root;
      if (Array.isArray(root)) return root.map(function (r) {
        return getRoot(r);
      });
      if (root.__collect) root.__collect.isRoot = true;
      return root.__collect || root;
    };

    return {
      root: getRoot(root),
      elements
    };
  }

  push(fn, component, props, children) {
    props = props || {};
    const node = {
      __collect: {
        fn,

        /* cid: this.elements.length, */
        component,
        props,
        children
      },
      $$typeof: REACT_ELEMENT_TYPE,
      props,
      ref: props.ref || null,
      key: props.key || null,
      type: component,
      _store: {
        validated: Boolean(component) && (typeof component === 'string' || component.prototype instanceof _react.default.Component)
      }
    };
    this.elements.push(node);
    return node;
  }

  render(ctx, elements, each) {
    elements && elements.forEach(function (node) {
      var _el$fn;

      const el = node.__collect;
      delete node.__collect;
      each && each.call(ctx, el.component, el.props, el.children, Boolean(el.isRoot));

      let ret = (_el$fn = el.fn).call.apply(_el$fn, [_react.default, el.component, el.props].concat(_toConsumableArray(el.children)));

      if (ret) Object.defineProperties(node, Object.getOwnPropertyDescriptors(ret));
    });
  }

  wrap(fn, each, pre, after) {
    if (!fn || !_config.default.useCollect) return fn;
    let collect = this;
    return function render() {
      collect.start();
      let result = fn.apply(this, arguments);

      let _collect$end = collect.end(result),
          root = _collect$end.root,
          elements = _collect$end.elements;

      pre && pre(root);
      collect.render(this, elements, each);
      after && after(result);
      return result;
    };
  }

}

var _default = new Collect();

exports.default = _default;