"use strict";

require("core-js/modules/web.dom.iterable");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "VUE_LIKE_METHODS", {
  enumerable: true,
  get: function () {
    return _beforeAction.VUE_LIKE_METHODS;
  }
});
exports.default = exports.REACT_LIFECYCLE_HOOKS = void 0;

var _utils = require("./utils");

var _beforeCollect = _interopRequireDefault(require("./before-collect"));

var _beforeProps = _interopRequireDefault(require("./before-props"));

var _beforeAction = _interopRequireWildcard(require("./before-action"));

var _component = _interopRequireDefault(require("./component"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const REACT_LIFECYCLE_HOOKS = ['render', 'renderError', 'componentDidMount', 'getSnapshotBeforeUpdate', 'componentDidUpdate', 'componentDidActivate', 'componentWillUnactivate', 'componentWillUnmount', 'componentDidCatch'];
exports.REACT_LIFECYCLE_HOOKS = REACT_LIFECYCLE_HOOKS;

function replaceVueLikeProto(target) {
  let ret = {};
  let isVueLike = (0, _utils.isVueLikeClass)(target);
  let tp = target.prototype;
  const tm = Object.getOwnPropertyNames(tp);
  let methods = isVueLike ? REACT_LIFECYCLE_HOOKS : _beforeAction.VUE_LIKE_METHODS;
  methods.forEach(function (key) {
    if (isVueLike && !tm.includes(key)) return;
    let sfn = _component.default.prototype[key];

    if ((0, _utils.hasOwnProperty)(tp, key)) {
      let tfn = tp[key];
      tp[key] = sfn;
      ret[key] = tfn;
    } else if (!isVueLike) (0, _utils.innumerable)(tp, key, sfn);
  });
  return ret;
}

function walkMixins(mixins, target) {
  mixins.forEach(function (mixin) {
    // eslint-disable-next-line
    if (mixin.props) target = (0, _beforeProps.default)(mixin, target);
    (0, _beforeAction.default)(mixin);
  });
}

function vuelikeConstructor(target, props, children) {
  if (target.vuelikeProto) return;
  const vuelikeProto = replaceVueLikeProto(target);
  (0, _utils.innumerable)(target, 'vuelikeProto', vuelikeProto);

  if ((0, _utils.hasOwnProperty)(target.prototype, 'shouldComponentUpdate')) {
    vuelikeProto.shouldComponentUpdate = target.prototype.shouldComponentUpdate;
    delete target.prototype.shouldComponentUpdate;
  }

  (0, _beforeCollect.default)(vuelikeProto, _component.default); // Object.keys(props).forEach(key => {
  //   if (!/^\$/.test(key)) return;
  //   Object.defineProperty(props, key, Object.assign(Object.getOwnPropertyDescriptor(props, key), { enumerable: false }));
  // });

  if (props.ref) {
    props.$ref = props.ref; // innumerable(props, '$ref', props.ref);

    delete props.ref;
  }

  let mixins = [target];
  if (target.mixins) Array.prototype.push.apply(mixins, target.mixins);
  walkMixins(mixins, target);
}

var _default = vuelikeConstructor;
exports.default = _default;