"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _mobx = require("./mobx");

var _config = _interopRequireDefault(require("./config"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Directive extends _react.default.Component {
  constructor(props) {
    super(props);
    this.state = {
      isMounted: false
    };
  }

  componentDidMount() {
    var _this = this;

    (0, _utils.iterativeParent)(this, function (parent) {
      return _this.$parent = parent;
    }, function (vm) {
      return vm._isVueLike;
    });
    if (!this.$parent) throw new Error('[ReactVueLike error]: can not find directive parent component');

    const _pending = function () {
      _this.$directives = _this.$parent.$directives;

      _this._call('bind');

      _this._mountPending = function () {
        _this._mountPending = null;
        setTimeout(function () {
          return _this._call('inserted');
        }, 0);
      };

      _this.setState({
        isMounted: true
      });
    };

    if (this.$parent._isWillMount) _pending();else this.$parent._mountedPending.push(_pending);
  }

  componentDidUpdate(prevProps, prevState, snapshot) {
    if (this._mountPending) this._mountPending();else this._call('componentUpdated');
  }

  getSnapshotBeforeUpdate(prevProps, prevState) {
    this._call('update');

    return null;
  }

  componentWillUnmount() {
    this._call('unbind');
  }

  _updateRef(r) {
    let ref = this.props.$ref;

    if (ref) {
      if ((0, _utils.isFunction)(ref)) ref(r);else if ((0, _utils.isObject)(ref)) ref.current = r;
    }
  }

  _call(eventName) {
    var _this2 = this;

    const el = _reactDom.default.findDOMNode(this);

    this.props._bindings.forEach(function (binding) {
      let d = _this2.$directives[binding.name];

      if (!d) {
        if (process.env.NODE_ENV !== 'production') {
          (0, _utils.warn)(`directive '${binding.name}' not be found!`);
        }

        return;
      }

      let event = d[eventName];
      if (!event) return;
      if (_config.default.enforceActions) event = (0, _mobx.action)(event);
      event.call(_this2.$parent, el, binding, _this2._reactInternalFiber);
    });
  }

  render() {
    var _this3 = this;

    if (!this.state.isMounted) return null; // eslint-disable-next-line

    const _this$props = this.props,
          _source = _this$props._source,
          _bindings = _this$props._bindings,
          children = _this$props.children,
          props = _objectWithoutProperties(_this$props, ["_source", "_bindings", "children"]);

    return _react.default.createElement(_source, Object.assign(props, {
      ref: function (ref) {
        return _this3._updateRef(ref);
      }
    }), children);
  }

}

_defineProperty(Directive, "propTypes", {
  _source: _propTypes.default.oneOfType([_propTypes.default.string.isRequired, _propTypes.default.elementType.isRequired]),
  _bindings: _propTypes.default.array.isRequired
});

Directive.__vueLikeDirective = true;
var _default = Directive;
exports.default = _default;